clear
close all
clc
qTTStart= now();
%
HHMMSS= 13;
FS= 16384;      % Sampling frequency
MS= 1000;       % Milisenconds in a second
TOLERANCE= 2*eps;
NCUTS= 63;
NCUTS4= floor(NCUTS/4);
NCUTS2= floor(NCUTS/2);
%
%General init
load  t63Cuts61 % Load t63Cuts61, kCutN and kMSeq63
NLEN= numel(t63Cuts61(:,1));        %9830
TLENms=  ceil(MS* NLEN/FS);
btt= 0:(TLENms -1);             % Time ms start of every ms window
bkk= 1+floor(btt*NLEN/TLENms);  % Index start of every ms window
bWindTimettDur= 10:400;         % From 010ms to 400ms in 001ms steps
qWindN= 0;

tkMatchCntkMatchLocskkFrug61= zeros(numel(bWindTimettDur), 3);
tkMatchCntkMatchLocskkArq61= zeros(numel(bWindTimettDur), 3);

%qWindTimettDur= From 010ms to 400ms in 001ms steps
for qWindTimettDur= bWindTimettDur        % ms
    qWindLenkkDur= -1 + bkk(qWindTimettDur+1);
    qWindN= qWindN +1; disp(qWindN);
    
    %All 1 ms slices from time axis start to end; MSeq is estimated at each
    bSliceStartInx= 1:(NLEN - qWindLenkkDur);       % kk indexes of Slices start
    bSliceCount= numel(bSliceStartInx);             % Number of slices == number of estimated MSeqs
    qSliceN= 0;
    
    kMSeqEstFrug= zeros(NCUTS, 1);     % Mind that we will estimate a total of bSliceCount kMSeqs with len== NCUTS
    kMatchCntFrug= zeros(bSliceCount,1);
    
    kMSeqEstArq= zeros(NCUTS, 1);     % Mind that we will estimate a total of bSliceCount kMSeqs with len== NCUTS
    kMatchCntArq= zeros(bSliceCount,1);
    
    
    for qCurrStartnn= bSliceStartInx                % At all start Indexes
        qCurrEndnn= -1+ qCurrStartnn + qWindLenkkDur;   % Find the End
        qSliceN= qSliceN +1;
        %Normalize all cuts to unit energy
        tem63Cuts61= 0*t63Cuts61(qCurrStartnn:qCurrEndnn,:);
        for nn=1:NCUTS
            kCurr= t63Cuts61(qCurrStartnn:qCurrEndnn,nn);
            kmCurr= kCurr- mean(kCurr);
            tem63Cuts61(:,nn)= kmCurr*(1/sqrt(kmCurr'*kmCurr));
        end
        
        
        % - - - - - - - - - - - - - - - - - - - - - - - - - - -
        % Start Frugal
        
        if qSliceN== 1
            qLL= numel(tem63Cuts61(:,1)); bLL= 0:(qLL-1);
            qBStep= 1/(qLL-1); qRStep= -1/(qLL-1);
            bBluFrug= qBStep*bLL; bRedFrug=  qRStep*bLL;
            kmBluFrug= (bBluFrug-mean(bBluFrug))';   kemBluFrug= kmBluFrug*(1/sqrt(kmBluFrug'*kmBluFrug));
            kmRedFrug= (bRedFrug-mean(bRedFrug))';   kemRedFrug= kmRedFrug*(1/sqrt(kmRedFrug'*kmRedFrug));
        end
        
        %Find the kMSEq for this window
        for kk=1:NCUTS
            bCurrCutFrug= (tem63Cuts61(:,kk))';
            if (bCurrCutFrug* kemBluFrug) > (bCurrCutFrug* kemRedFrug)
                kMSeqEstFrug(kk)= 1;
            else
                kMSeqEstFrug(kk)= -1;
            end
        end
        
        %Find the match count
        qMSeqEstCntFrug= sum(kMSeqEstFrug== kMSeq63);
        if qMSeqEstCntFrug <= NCUTS2      % Switch Red, Blu
            kTemp= kemBluFrug; kemBluFrug= kemRedFrug; kemRedFrug= kTemp;
            kMSeqEstFrug= -kMSeqEstFrug;
            qMSeqEstCntFrug= NCUTS- qMSeqEstCntFrug;
        end
        kMatchCntFrug(qSliceN)= qMSeqEstCntFrug;
        
        
        
        % End Frugal
        % - - - - - - - - - - - - - - - - - - - - - - - - - - -
        
        tRho= corr(tem63Cuts61); tRho(tRho== 1)= 0;   %Corr with null main diagonal
        qMm= min(min(tRho));
        [ll, cc]= find(tRho== qMm); qll= ll(1); qcc= cc(1);
        kBlu63= flip(sort(tRho(:,qll)));
        kRed63= flip(sort(tRho(:,qcc)));
        
        %Find the first 25%
        kBlu= kBlu63(1:NCUTS4) ;
        kTempB= tRho(qll,:)';
        ikBluFull= sort(((1:63)').*ismembertol(kTempB ,kBlu, TOLERANCE));
        ikBlu= ikBluFull((end-NCUTS4+1):end);   %ikBlu must have 15 good indexes
        
        kRed= kRed63(1:NCUTS4) ;
        kTempR= tRho(:, qcc);
        ikRedFull= sort(((1:63)').*ismembertol(kTempR ,kRed, TOLERANCE));
        ikRed= ikRedFull((end-NCUTS4+1):end);   %ikRed must have 15 good indexes
        
        %Make the archetypes
        kRedArq= zeros(qWindLenkkDur,1);     kBluArq= kRedArq;
        for nn= 1:NCUTS4
            kCurrBlu= tem63Cuts61(:,ikBlu(nn));
            kCurrRed= tem63Cuts61(:,ikRed(nn));
            kBluArq= kBluArq + kCurrBlu;
            kRedArq= kRedArq + kCurrRed;
        end
        kmBluArq= kBluArq-mean(kBluArq);   kemBluArq= kmBluArq*(1/sqrt(kmBluArq'*kmBluArq));
        kmRedArq= kRedArq-mean(kRedArq);   kemRedArq= kmRedArq*(1/sqrt(kmRedArq'*kmRedArq));
        
        
        %Find the kMSEq for this window
        for kk=1:NCUTS
            bCurrCut= (tem63Cuts61(:,kk))';
            if (bCurrCut* kemBluArq) > (bCurrCut* kemRedArq)
                kMSeqEstArq(kk)= 1;
            else
                kMSeqEstArq(kk)= -1;
            end
        end
        
        %Find the match count
        qMatchCntArq= sum(kMSeqEstArq== kMSeq63);
        if qMatchCntArq <= NCUTS2      % Switch Red, Blu
            kTemp= kemBluArq; kemBluArq= kemRedArq; kemRedArq= kTemp;
            kMSeqEstArq= -kMSeqEstArq;
            qMatchCntArq= NCUTS- qMatchCntArq;
        end
        kMatchCntArq(qSliceN)= qMatchCntArq;
        
        
    end     %     for qStartnn= 1:qWindLenDur:NLEN
    
    
    qMMaxCntFrug= max(max(kMatchCntFrug));
    qMMaxLockkBorderLeftFrug= find(kMatchCntFrug== qMMaxCntFrug, 1 ,'first');
    qMMaxLockkBorderRighFrug= find(kMatchCntFrug== qMMaxCntFrug, 1, 'last' );
    tkMatchCntkMatchLocskkFrug61(qWindN,:)= [ qMMaxCntFrug; qMMaxLockkBorderLeftFrug; qMMaxLockkBorderRighFrug];
    
    
    qMMaxCntArq= max(max(kMatchCntArq));
    qMMaxLockkBorderLeftArq= find(kMatchCntArq== qMMaxCntArq, 1 ,'first');
    qMMaxLockkBorderRighArq= find(kMatchCntArq== qMMaxCntArq, 1, 'last' );
    tkMatchCntkMatchLocskkArq61(qWindN,:)= [ qMMaxCntArq; qMMaxLockkBorderLeftArq; qMMaxLockkBorderRighArq];
    
    
end     % for qWindTimeDur= 10:400


figure(1)
plot(tkMatchCntkMatchLocskkArq61(:,1),'b'); hold  on;
plot(tkMatchCntkMatchLocskkFrug61(:,1),'m');
plot(0*tkMatchCntkMatchLocskkArq61 + NCUTS - NCUTS4 -0.5,'r');
plot(0*tkMatchCntkMatchLocskkArq61 +57.5,'g');
plot(0*tkMatchCntkMatchLocskkArq61 + 32,'k');hold off
title('Matches61 cnt');  xlabel('Window tt Length (ms)'); grid on;
axis([0 400 30 64]);
legend('Arq', 'Frug','Location','East');
pause(0.1);

save From010msTo400msArqAndFrugal61 tkMatchCntkMatchLocskkArq61 tkMatchCntkMatchLocskkFrug61


disp('Done 61')
qTTEnd= now();
qTTDur= qTTEnd-qTTStart;
disp(datestr(qTTDur, HHMMSS));

disp('  ')



