close all
clear all
clc
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MSeq generator
% 6 bit seed - 63 bits length  
%
% List of Primitive polynomials, as listed in 
% https://www.embeddedrelated.com/showarticle/1193.php
% Linear Feedback Shift Registers for the Uninitiated _  Sachs -2018 -2024
% 
%  67  0103  43h  1000011    ddN== 033
%  91  0133  5bh  1011011    ddN== 045
%  97  0141  61h  1100001    ddN== 048
% 103  0147  67h  1100111    ddN== 051
% 109  0155  6dh  1101101    ddN== 054
% 115  0163  73h  1110011    ddN== 057

% ddN= 033;           % MSeq ID
% ddN= 045;           % MSeq ID
% ddN= 048;           % MSeq ID
% ddN= 051;           % MSeq ID
% ddN= 054;           % MSeq ID
% ddN= 057;           % MSeq ID
% ddN= 021;           % Not valid MSeq 

ddMBITS=63;         % MSeq Lenght== 63
ddNDIGITS= 6;       % 6 Bits -> MSeq is 63 bits
ddPAUSE= 0.25;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

strBin= dec2bin(ddN,ddNDIGITS);

kx=zeros(ddNDIGITS,1);
for nn=1:ddNDIGITS
    if(strBin(nn)=='1')
        kx(nn)=1;
    end
    if(strBin(nn)=='0')
        kx(nn)=-1;
    end
end
%kx  a sequencia de 6 bots (bots: -uns e uns) geradora da MSeq de 63 bits
%kx is the sequence of 6 bots (bots: -ONEs and +ONEs) generating the 63-bit MSeq

%Vamos gerar a MSeq que ficar em ky
%Generating the MSeq to be stored in ky."

ky= zeros(ddMBITS,1);
for nn= 1: ddMBITS
    x0=kx(5)*kx(6);
    ky(nn)= x0;
    kx=[ x0; kx(1:5)];
end


%---------------------------------------------------------
%MSeq gerada, vamos mostr-la
%MSeq generated, let's show it


fwrite(1,newline);
for nn=1:ddMBITS
    fwrite(1,sprintf('%2d  ',ky(nn)));
    if (round(nn/4)*4==nn)
        fwrite(1,sprintf(' '));
    end
    if (round(nn/8)*8==nn)
        fwrite(1,newline);
    end
    if nn==32
         fwrite(1,newline);
    end
end
fwrite(1,newline);

%---------------------------------------------------------
%vamos ver a autocorr
%Lets look at the autocorr

stem(cconv(ky, flip(ky), ddMBITS))
xlabel(ddN);

