%This script finds the most similar MSeq, in the Hamming distance sense
%
clear
close all
clc
%

load('M63SeqsAll.mat')  % tM63Seq067, tM63Seq091, tM63Seq097, tM63Seq103, tM63Seq109, tM63Seq115
load('kbMSeq00.mat')    % kb
 
kUnknown= -1+ 2*(rand(63,1) > 0.5);
% kUnknown= kb;

[qMSeqP067, qMatchCntP067]= FindMaxSimilar(kUnknown, tM63Seq067);
[qMSeqP091, qMatchCntP091]= FindMaxSimilar(kUnknown, tM63Seq091);
[qMSeqP097, qMatchCntP097]= FindMaxSimilar(kUnknown, tM63Seq097);
[qMSeqP103, qMatchCntP103]= FindMaxSimilar(kUnknown, tM63Seq103);
[qMSeqP109, qMatchCntP109]= FindMaxSimilar(kUnknown, tM63Seq109);
[qMSeqP115, qMatchCntP115]= FindMaxSimilar(kUnknown, tM63Seq115);

[qMSeqM067, qMatchCntM067]= FindMaxSimilar(kUnknown, -tM63Seq067);
[qMSeqM091, qMatchCntM091]= FindMaxSimilar(kUnknown, -tM63Seq091);
[qMSeqM097, qMatchCntM097]= FindMaxSimilar(kUnknown, -tM63Seq097);
[qMSeqM103, qMatchCntM103]= FindMaxSimilar(kUnknown, -tM63Seq103);
[qMSeqM109, qMatchCntM109]= FindMaxSimilar(kUnknown, -tM63Seq109);
[qMSeqM115, qMatchCntM115]= FindMaxSimilar(kUnknown, -tM63Seq115);




tMatches= [qMSeqP067, qMatchCntP067;...
           qMSeqP091, qMatchCntP091;...
           qMSeqP097, qMatchCntP097;...
           qMSeqP103, qMatchCntP103;...
           qMSeqP109, qMatchCntP109;...
           qMSeqP115, qMatchCntP115;...
           qMSeqM067, qMatchCntM067;...
           qMSeqM091, qMatchCntM091;...
           qMSeqM097, qMatchCntM097;...
           qMSeqM103, qMatchCntM103;...
           qMSeqM109, qMatchCntM109;...
           qMSeqM115, qMatchCntM115];

qMatchMax= max(tMatches(:,2));
qLineMatch= find(tMatches(:,2)== qMatchMax, 1, 'first'); 

switch  qLineMatch
    case 1
        fprintf('Match count= %02d\n', qMatchCntP067)
        fprintf('MSeq %02d from set P067\n',qMSeqP067);
    case 2
        fprintf('Match count= %02d\n', qMatchCntP091)
        fprintf('MSeq %02d from set P091\n',qMSeqP091);
    case 3
        fprintf('Match count= %02d\n', qMatchCntP097)
        fprintf('MSeq %02d from set P097\n',qMSeqP097);
    case 4
        fprintf('Match count= %02d\n', qMatchCntP103)
        fprintf('MSeq %02d from set P103\n',qMSeqP103);
    case 5
        fprintf('Match count= %02d\n', qMatchCntP109)
        fprintf('MSeq %02d from set P109\n',qMSeqP109);
    case 6
        fprintf('Match count= %02d\n', qMatchCntP115)
        fprintf('MSeq %02d from set P115\n',qMSeqP115);
    case 7
        fprintf('Match count= %02d\n', qMatchCntM067)
        fprintf('MSeq %02d from set M067\n',qMSeqM067);
    case 8
        fprintf('Match count= %02d\n', qMatchCntM091)
        fprintf('MSeq %02d from set M091\n',qMSeqM091);
    case 9
        fprintf('Match count= %02d\n', qMatchCntM097)
        fprintf('MSeq %02d from set M097\n',qMSeqM097);
    case 10
        fprintf('Match count= %02d\n', qMatchCntM103)
        fprintf('MSeq %02d from set M103\n',qMSeqM103);
    case 11
        fprintf('Match count= %02d\n', qMatchCntM109)
        fprintf('MSeq %02d from set M109\n',qMSeqM109);
    case 12
        fprintf('Match count= %02d\n', qMatchCntM115)
        fprintf('MSeq %02d from set M115\n',qMSeqM115);
    otherwise
        disp('oops')
end





disp('... ');

