function all_cuts = tCuts_func(ksig1,ksig2,ksig3,ksig4,ksig5,ksig6,ksig7,ksig8,qFs,CUTLEN_n,CUTLEFT_n,kBitsStart)
%this function cuts the signals by using CUTLEN and CUUTLEFT values.
%(CUTLEN=lenght of the cut
%CUTLEFT= lenght of the part before the bit)
%after cutting signals by using kBitsStart folder,
%it removes mean of each cut
%and take diffirence of each channel to generate signals and store them
i_signals=[ksig1,ksig2,ksig3,ksig4,ksig5,ksig6,ksig7,ksig8];

k01cut=cut_func(i_signals(:,1),qFs,CUTLEN_n,CUTLEFT_n,kBitsStart);
k02cut=cut_func(i_signals(:,2),qFs,CUTLEN_n,CUTLEFT_n,kBitsStart);
k03cut=cut_func(i_signals(:,3),qFs,CUTLEN_n,CUTLEFT_n,kBitsStart);
k04cut=cut_func(i_signals(:,4),qFs,CUTLEN_n,CUTLEFT_n,kBitsStart);
k05cut=cut_func(i_signals(:,5),qFs,CUTLEN_n,CUTLEFT_n,kBitsStart);
k06cut=cut_func(i_signals(:,6),qFs,CUTLEN_n,CUTLEFT_n,kBitsStart);
k07cut=cut_func(i_signals(:,7),qFs,CUTLEN_n,CUTLEFT_n,kBitsStart);
k08cut=cut_func(i_signals(:,8),qFs,CUTLEN_n,CUTLEFT_n,kBitsStart);

k12cut=k01cut-k02cut;
k13cut=k01cut-k03cut;
k14cut=k01cut-k04cut;
k15cut=k01cut-k05cut;
k16cut=k01cut-k06cut;
k17cut=k01cut-k07cut;
k18cut=k01cut-k08cut;
k23cut=k02cut-k03cut;
k24cut=k02cut-k04cut;
k25cut=k02cut-k05cut;
k26cut=k02cut-k06cut;
k27cut=k02cut-k07cut;
k28cut=k02cut-k08cut;
k34cut=k03cut-k04cut;
k35cut=k03cut-k05cut;
k36cut=k03cut-k06cut;
k37cut=k03cut-k07cut;
k38cut=k03cut-k08cut;
k45cut=k04cut-k05cut;
k46cut=k04cut-k06cut;
k47cut=k04cut-k07cut;
k48cut=k04cut-k08cut;
k56cut=k05cut-k06cut;
k57cut=k05cut-k07cut;
k58cut=k05cut-k08cut;
k67cut=k06cut-k07cut;
k68cut=k06cut-k08cut;
k78cut=k07cut-k08cut;

all_cuts = struct('k01_cut',k01cut,'k02_cut',k02cut,'k03_cut',k03cut,'k04_cut',k04cut,'k05_cut',k05cut, ...
    'k06_cut',k06cut,'k07_cut',k07cut,'k08_cut',k08cut,'k12_cut',k12cut,'k13_cut',k13cut, ...
    'k14_cut',k14cut,'k15_cut',k15cut,'k16_cut',k16cut,'k17_cut',k17cut,'k18_cut',k18cut, ...
    'k23_cut',k23cut,'k24_cut',k24cut,'k25_cut',k25cut,'k26_cut',k26cut,'k27_cut',k27cut,'k28_cut',k28cut, ...
    'k34_cut',k34cut,'k35_cut',k35cut,'k36_cut',k36cut,'k37_cut',k37cut,'k38_cut',k38cut, ...
    'k45_cut',k45cut,'k46_cut',k46cut,'k47_cut',k47cut,'k48_cut',k48cut,'k56_cut',k56cut, ...
    'k57_cut',k57cut,'k58_cut',k58cut,'k67_cut',k67cut,'k68_cut',k68cut,'k78_cut',k78cut)
end

function tCuts= cut_func(ksig,qFs,CUTLEN_n,CUTLEFT_n,kBitsStart)
CUTLEN= fix(CUTLEN_n*qFs);               
CUTLEFT= fix(CUTLEFT_n*qFs);
qNCuts = numel(kBitsStart);
tCuts= zeros(CUTLEN, qNCuts)+ 3*max(ksig);
for nn= 1:qNCuts
    qStartCut= kBitsStart(nn)- CUTLEFT;
    qEndCut= qStartCut + CUTLEN -1;
    bCurrCut= ksig(qStartCut:qEndCut)';
    tCuts(:,nn)= remove_mean(bCurrCut);
end    
end


function mean_removed=remove_mean(sig) 
mean_removed= sig - mean(sig);
end
